package ru.ifmo.ga.ca;

import ru.ifmo.ga.ca.configuration.ConfigurationFactory;
import ru.ifmo.ga.ca.gui.CAFrame;
import ru.ifmo.ga.ca.randomizer.Randomizer;
import ru.ifmo.ga.ca.randomizer.RandomizerFactory;

import javax.swing.*;

/**
 * User: Yuri D. Bedny
 * Date: Apr 8, 2006
 * Time: 2:20:43 PM
 */

public class SimpleGUITest {
    public static void main(String[] args) throws Exception {
        final Rule rule = new Rule();
        rule.setRadius(3);
        rule.parseRule(KnownCARepository.JP_1);
        rule.setInfo("Juille - Pollack, radius 3");

        final SimpleCA ca = new SimpleCA();
        Randomizer rnd = new RandomizerFactory(RandomizerFactory.Imlementation.EveryBit, ConfigurationFactory.Implementation.BitSet).create(10);
        ca.setSize(10);
        ca.setRule(rule);
        ca.setConfiguration(rnd.random());

        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                new CAFrame(ca);
            }
        });

        for (int i = 0; i < 10; i++) {
            ca.next();
            Thread.sleep(1000);
        }
    }
}
