package ru.ifmo.ga.ca.configuration;

/**
 * User: Yuri D. Bedny
 * Date: Apr 2, 2006
 * Time: 12:59:52 PM
 */

class BitSetConfiguration extends AbstractConfiguration {
    private BitSet bs;

    protected void init() {
        bs = new BitSet(size);
    }

    public BitSetConfiguration(int size) {
        super(size);
    }

    public BitSetConfiguration(int size, long x) throws IllegalArgumentException{
        super(size, x);
    }

    public BitSetConfiguration(String s) throws IllegalArgumentException {
        super(s);
    }

    public BitSetConfiguration(boolean[] f) {
        super(f);
    }

    public int cardinality() {
        return bs.cardinality();
    }

    public void clear() {
        bs.clear();
    }

    public boolean get(int i) {
        return bs.get(i);
    }

    public void set(int i, boolean b) {
        bs.set(i, b);
    }

    public long toLong() {
        return bs.bits[0];
    }

    public Configuration clone() {
        BitSetConfiguration c = (BitSetConfiguration) super.clone();
        c.bs = (BitSet) bs.clone();
        return c;
    }

    public boolean[] toBooleanArray() {
        //todo imlement
        throw new RuntimeException("Not implemented");
    }
}
