package ru.ifmo.ga.ca.dct;

import ru.ifmo.ga.fx.AbstractPoint;
import ru.ifmo.ga.fx.Point;
import ru.ifmo.ga.fx.PointMetadata;
import ru.ifmo.ga.ca.Rule;

import java.io.*;
import java.util.Arrays;

public class CAPoint extends AbstractPoint {

    private Rule rule = new Rule();
    private CAPointMetadata metadata = new CAPointMetadata();

    public CAPoint clone() {
        CAPoint point = (CAPoint) super.clone();
        point.setRule(new Rule(rule));
        point.setMetadata(metadata.clone());
        return point;
    }

    public Rule getRule() {
        return rule;
    }

    public void setRule(Rule rule) {
        this.rule = rule;
    }

    public CAPointMetadata getMetadata() {
        return metadata;
    }

    public void save(DataOutputStream os) throws IOException {
        // rule
        os.writeInt(rule.getRadius());
        for (int i = 0; i < rule.getLength(); i++) {
            os.writeBoolean(rule.getBit(i));
        }

        // pointMetadata
        os.writeDouble(metadata.getValue());
        os.writeInt(metadata.getTestCases());
    }

    public void load(DataInputStream is) throws IOException {
        // rule
        rule.setRadius(is.readInt());
        for (int i = 0; i < rule.getLength(); i++) {
            rule.setBit(i, is.readBoolean());
        }

        // pointMetadata
        getMetadata().setValue(is.readDouble());
        getMetadata().setTestCases(is.readInt());
    }

    public int compareTo(Point p) {
        CAPoint ca = (CAPoint) p;
        if (ca.getRule().equals(rule)) {
            return 0;
        }

        int r = super.compareTo(p);
        if (r == 0) {
            return ca.getRule().toString().compareTo(rule.toString());
        }

        return r;
    }

    public void setMetadata(PointMetadata metadata) {
        this.metadata = (CAPointMetadata) metadata;
    }
}
