package ru.ifmo.ga.ca.dct.modules;

import ru.ifmo.ga.ca.tree.Tree;
import ru.ifmo.ga.ca.Rule;
import ru.ifmo.ga.ca.dct.modules.GP;

import java.util.ArrayList;

/**
 * User: Yuri D. Bedny
 * Date: Jun 1, 2006
 * Time: 5:55:27 PM
 */

public class GPUtils {

    public static Tree getRandomNode(Tree t) {
        ArrayList<Tree> nodes = t.getNodes();
        int d = (int) (Math.random() * nodes.size());
        return nodes.get(d);
    }

    public static void mutate(Tree t) {
        Tree x = getRandomNode(t);
        int pos = (int)(Math.random() * (GP.VARS.length + 1));
        if (x.isTerminal() || pos == GP.VARS.length) {
            x.tryFlipTerminal(Math.random() > 0.5);
        } else {
            x.setVarNum(pos);
        }
    }

    public static void copy(Tree src, Tree dst) {// deep copy
        dst.setTerminal(src.isTruth(), src.isFalse());

        if (src.isTerminal()) {
            return;
        }

        assert (src.getThen() != null);
        assert (src.getElse() != null);

        dst.setVarNum(src.getVarNum());

        if (dst.getThen() == null) {
            dst.setThen(new Tree(false, GP.VARS));
        }
        if (dst.getElse() == null) {
            dst.setElse(new Tree(false, GP.VARS));
        }

        copy(src.getThen(), dst.getThen());
        copy(src.getElse(), dst.getElse());
    }

    public static boolean equals(Tree t1, Tree t2) {
        Rule r1 = new Rule();
        r1.setRadius(GP.RULE_RADIUS);

        Rule r2 = new Rule();
        r2.setRadius(GP.RULE_RADIUS);

        getRule(r1, t1);
        getRule(r2, t2);

        return r1.equals(r2);
    }

    
    public static void getRule(Rule r, Tree t) {
        r.setTable(t.toRule().getTable());
    }

}
