package ru.ifmo.ga.ca.dct.modules;

import ru.ifmo.ga.fx.Point;
import ru.ifmo.ga.ca.Rule;
import ru.ifmo.ga.ca.dct.CAPoint;

import java.util.TreeSet;
import java.util.HashSet;

public class PointsSet extends TreeSet<Point> {
    private final HashSet<Rule> rules = new HashSet<Rule>();
    public boolean contains(Object o) {
        CAPoint ca = (CAPoint) o;
        return rules.contains(ca.getRule());
    }

    public boolean add(Point o) {
        CAPoint ca = (CAPoint) o;
        if (rules.add(ca.getRule())) {
            return super.add(o);
        } else {
            return false;
        }
    }

    public boolean remove(Object o) {
        CAPoint ca = (CAPoint) o;
        if (rules.remove(ca.getRule())) {
            return super.remove(o);
        } else {
            return false;
        }
    }

}
