package ru.ifmo.ga.ca.gui;

import ru.ifmo.ga.ca.CAEvent;
import ru.ifmo.ga.ca.SimpleCA;

import java.util.ArrayList;

/**
 * User: Yuri D. Bedny
 * Date: Apr 8, 2006
 * Time: 2:30:32 PM
 */

public class DefaultCAModel implements CAModel {
    private SimpleCA ca;
    private ArrayList<CAModelListener> listeners = new ArrayList<CAModelListener>();

    public void next(CAEvent e) {
        fireCAChanged(new CAModelEvent(e));
    }

    public void stopped(CAEvent e) {
        fireCAChanged(new CAModelEvent(e));
    }

    public SimpleCA getCa() {
        return ca;
    }

    public void setCa(SimpleCA ca) {
        this.ca = ca;
        ca.addCAListener(this);
        fireCAChanged(new CAModelEvent());
    }

    public void addCAModelListener(CAModelListener l) {
        listeners.add(l);
    }

    public void removeCAModelListener(CAModelListener l) {
        listeners.remove(l);
    }

    private void fireCAChanged(CAModelEvent e) {
        for(CAModelListener l : listeners) {
            l.caChanged(e);
        }
    }
}
