package ru.ifmo.ga.ca.randomizer;

import ru.ifmo.ga.ca.configuration.Configuration;
import ru.ifmo.ga.ca.configuration.ConfigurationFactory;

/**
 * User: Yuri D. Bedny
 * Date: Apr 2, 2006
 * Time: 8:49:55 PM
 */

class OverDensityRandomizer extends AbstractRandomizer {
    public OverDensityRandomizer(ConfigurationFactory.Implementation impl, int size) {
        super(impl, size);
    }

    public Configuration random() {
        Configuration cfg = factory.create(size);
        int d = (int) (Math.random() * (size + 1));
        for (int j = 0; j < d; j++) {
            int p = (int) (Math.random() * size);
            while (cfg.get(p)) {
                p = (int) (Math.random() * size);
            }
            cfg.set(p, true);
        }
        return cfg;
    }

}
