package ru.ifmo.ga.ca.tournament;

import ru.ifmo.ga.ca.Rule;

import java.util.ArrayList;

/**
 * User: Yuri D. Bedny
 * Date: Apr 9, 2006
 * Time: 11:14:29 AM
 */
public class Result implements Comparable {//decorator??
    private final CAContext ctx;
    private final boolean both;

    public int compareTo(Object o) {
        if (!(o instanceof Result))
            return 0;

        Result r = (Result) o;
        if (getWin() > r.getWin())
            return 1;
        else if (getWin() < r.getWin())
            return -1;
        return 0;
    }

    public Result(CAContext ctx) {
        this.ctx = ctx;

        boolean one = false;
        boolean zero = false;
        for (ICContext c : ctx.getWin()) {
            if (c.getCfg().isOnesMajority()) {
                one = true;
            } else {
                zero = true;
            }

            if (one && zero) {
                break;
            }
        }
        both = one && zero;
    }

    public boolean isBoth() {
        return both;
    }

    public ArrayList<ICContext> getWinCfgs() {
        return ctx.getWin();   
    }

    public ArrayList<ICContext> getLostCfgs() {
        return ctx.getLost();
    }

    public Rule getRule() {
        return ctx.getRule();
    }

    public double getValue() {
        return getWin() * 1.0 / (getWin() + getLost());
    }

    public int getLost() {
        return ctx.getLost().size();
    }

    public int getWin() {
        return ctx.getWin().size();
    }

    public String toString() {
        return ctx.getRule().getInfo() + " " + getValue() * 100 + "%";
    }
}
