package ru.ifmo.ga.ca.tournament;

import java.util.ArrayList;
import java.util.Collections;

/**
 * User: Yuri D. Bedny
 * Date: Apr 9, 2006
 * Time: 11:13:15 AM
 */
public class Results {
    private final ArrayList<ICContext> icCtxs;
    private final ArrayList<Result> results = new ArrayList<Result>();
    private final Settings settings;
    private final long startTime;
    private final long endTime;

    public Results(ArrayList<CAContext> caCtxs, ArrayList<ICContext> icCtxs, Settings settings, long startTime) {
        this.icCtxs = icCtxs;
        this.startTime = startTime;
        this.settings = new Settings(settings);
        this.endTime = System.currentTimeMillis();
        for (CAContext ctx : caCtxs) {
            results.add(new Result(ctx));
        }
    }

    public ArrayList<ICContext> getIcCtxs() {
        return icCtxs;
    }

    public Settings getSettings() {
        return settings;
    }

    public ArrayList<Result> getResults() {
        return results;
    }

    public long getWorkTime() {
        return (endTime - startTime) / 1000;
    }

    public long getStartTime() {
        return startTime;
    }

    public long getEndTime() {
        return endTime;
    }

    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("time: ").append(getWorkTime()).append("\n");
        sb.append(settings.toString()).append("\n");
        for (int i = 0; i < results.size(); i++) {
            sb.append(i+1).append(") ").append(results.get(i).toString());
            if (i < results.size() - 1)
                sb.append("\n");
        }
        return sb.toString();
    }

    public ArrayList<Result> sort() {
        Collections.sort(results);
        return results;
    }
}
