package ru.ifmo.ga.fx;

import ru.ifmo.ga.fx.desire.DownloadDesire;
import ru.ifmo.ga.fx.stat.Divergence;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.TreeSet;
import java.util.ArrayList;
import java.io.*;

public interface Repository extends Remote {
    Point downloadPoint(DownloadDesire desire) throws RemoteException;
    ArrayList<Point> downloadPoints(DownloadDesire desire) throws RemoteException;
    UploadResult uploadPoint(Point point) throws RemoteException;
    boolean replacePoint(Point oldPoint, Point newPoint) throws RemoteException;//todo: security check
    boolean removePoint(Point point) throws RemoteException;   

    void clear() throws RemoteException;

    String getName() throws RemoteException;
    Fitness getFitness() throws RemoteException;

    //todo: move to statistics
    double getMaxFitness() throws RemoteException;
    double getMinFitness() throws RemoteException;
    double getAvgFitness() throws RemoteException;
    double getAvgDivergence() throws RemoteException;
    Divergence getDivergence() throws RemoteException;
    // todo: end of issues list

    int getSize() throws RemoteException;
    int getMaxSize() throws RemoteException;
    void setMaxSize(int size) throws RemoteException;

    TreeSet<Point> getPoints() throws RemoteException;//todo: replace to downloadPoints
    double calculate(Point p) throws RemoteException;

    void save() throws IOException;
    void load() throws IOException;

}
