package ru.ifmo.ga.fx;

import java.util.Timer;
import java.util.TimerTask;
import java.util.Date;
import java.util.Hashtable;
import java.io.IOException;

public class RepositoryKeeper {

    private final Timer timer = new Timer(true);
    private final int SAVE_PERIOD_MINUTES = 5;

    public void schedule(final Hashtable<String, Repository> repositories) {
        timer.schedule(new TimerTask() {
            public void run() {
                for (Repository rep : repositories.values()) {
                    try {
                        rep.save();
                    } catch (IOException e) {
                        System.out.println("Can't save repository. " + e);
                    }
                }
            }
        }, SAVE_PERIOD_MINUTES * 60000, SAVE_PERIOD_MINUTES * 60000);
    }

}
