package ru.ifmo.ga.fx.desire;

import ru.ifmo.ga.fx.Point;
import ru.ifmo.ga.fx.Repository;

import java.rmi.RemoteException;
import java.util.Iterator;
import java.util.ArrayList;

public class SlightlyBetterPointDesire implements DownloadDesire {
    private final Point point;
    private final String clientName;

    public Point downloadPoint(Repository repository) throws RemoteException {
        double v = repository.getFitness().calculate(point);
        for (Point p : repository.getPoints()) {
            if (p.getMetadata().getValue() > v) {
                return p;
            }
        }
        return null;// no such point
    }

    public SlightlyBetterPointDesire(Point point) {
        this("", point);
    }

    public SlightlyBetterPointDesire(String clientName, Point point) {
        this.point = point;
        this.clientName = clientName;
    }

    public String getClientName() {
        return clientName;
    }

    public ArrayList<Point> downloadPoints(Repository repository) {
        return null;  //To change body of implemented methods use File | Settings | File Templates.
    }
}
